#include "base.h"

#include <QtDebug>

Base::Base()
   : _string("constructed")
   {
   qDebug() << Q_FUNC_INFO;
   }

Base::Base(const Base& b)
   : _string(b._string)
   {
   qDebug() << Q_FUNC_INFO;
   }

Base::Base(Base&& b) noexcept
   : _string(std::move(b._string))
   {
   qDebug() << Q_FUNC_INFO;
   }

Base& Base::operator =(Base&& b)
   {
   qDebug() << Q_FUNC_INFO;
   _string = std::move(b._string);
   return *this;
   }

const QString& Base::string() const &
   {
   qDebug() << Q_FUNC_INFO;
   return _string;
   }

QString Base::string() const &&
   {
   qDebug() << Q_FUNC_INFO;
   return std::move(_string);
   }
